/*
{*******************************************************************}
{                                                                   }
{          BDB 2007                                                 }
{          Res Controller                                           }
{                                                                   }
{          author: rain                                             }
{          date created: 2007/09/14                                 }
{          last update: 2007/09/15                                  }
{          remark: N/A                                              }
{                                                                   }
{          Ȩ(c) 2006-2007                            }
{          HTTP://WWW.BAINSOFT.COM                                  }
{          Copyright (c) 2006-2007 BAIN SOFTWARE                    }
{          ALL RIGHTS RESERVED                                      }
{                                                                   }
{*******************************************************************}
*/

import org.w3c.dom.*;     
import javax.xml.parsers.*;     

public class ResController {
	
    public static final String RSAX = "AX";
    public static final String RSTable = "TABLE";
    public static final String RSRows = "ROWS";
    public static final String RSIndexs = "TABLEINDEXS";
    public static final String RSConstraints = "TABLECONSTRAINTS";
    public static final String RSRow = "ROW";
    public static final String RSName = "NAME";
    public static final String RSValid = "VALID";
    public static final String RSVisible = "VISIBLE";
    public static final String RSRemark = "REMARK";
    public static final String RSTableName = "TABLENAME";

    //row
    public static final String RSResIndex = "RESINDEX";
    public static final String RSDisplayName = "DISPLAYNAME";
    public static final String RSHeaderSign = "HEADERSIGN";
    public static final String RSItemCount = "ITEMCOUNT";
    public static final String RSIndexCount = "INDEXCOUNT";
    public static final String RSConstraintCount = "CONSTRAINTCOUNT";
    public static final String RSPKName = "PKNAME";
    public static final String RSPK = "PK";
    public static final String RSVersion = "VERSION";
    public static final String RSCreateSign = "CREATESIGN";
    public static final String RSCreateTime = "CREATETIME";
    public static final String RSLastUpdateSign = "LASTUPDATESIGN";
    public static final String RSLastUpdateTime = "LASTUPDATETIME";
    public static final String RSIsPK = "ISPK";
    public static final String RSIndex = "INDEX";
    public static final String RSTypeName = "TYPENAME";
    public static final String RSPrecision = "PRECISION";
    public static final String RSLength = "LENGTH";
    public static final String RSAllowNull = "ALLOWNULL";
    public static final String RSIdentity = "IDENTITY";
    public static final String RSDefault = "DEFAULT";
    public static final String RSOldColumnName = "OLDCOLUMNNAME";
    public static final String RSDisplayWidth = "DIPLAYWIDTH";
    public static final String RSPickList = "PICKLIST";
    public static final String RSSource = "SOURCE";
    public static final String RSSourceItems = "SOURCEITEMS";
    public static final String RSDestItems = "DESTITEMS";
    public static final String RSReserved1 = "RESERVED1";
    public static final String RSReserved2 = "RESERVED2";
    public static final String RSReserved3 = "RESERVED3";
    public static final String RSReserved4 = "RESERVED4";
    public static final String RSReserved5 = "RESERVED5";
    public static final String RSReserved6 = "RESERVED6";
    public static final String RSReserved7 = "RESERVED7";

    //index
    public static final String RSIndexName = "INDEXNAME";
    public static final String RSPrimaryKey = "PRIMARYKEY";
    public static final String RSConstraint = "CONSTRAINT";
    public static final String RSUnique = "UNIQUE";
    public static final String RSClustered = "CLUSTERED";
    public static final String RSIndexType = "INDEXTYPE";
    public static final String RSAutoUpdate = "AUTOUPDATE";
    public static final String RSNullCollation = "NULLCOLLATION";
    public static final String RSOrdinalPosition = "ORDINALPOSITION";
    public static final String RSColumnName = "COLUMNNAME";
    public static final String RSCollation = "COLLATION";
    public static final String RSCardinality = "CARDINALITY";
    public static final String RSIntegrated = "INTEGRATED";

    //relation
    public static final String RSPKTableName = "PKTABLENAME";
    public static final String RSPKColumnName = "PKCOLUMNNAME";
    public static final String RSFKTableName = "FKTABLENAME";
    public static final String RSFKColumnName = "FKCOLUMNNAME";
    public static final String RSOrdinal = "ORDINAL";
    public static final String RSUpdateRule = "UPDATERULE";
    public static final String RSDeleteRule = "DELETERULE";
    public static final String RSFKName = "FKNAME";
    public static final String RSDeferrability = "DEFERRABILITY";

    private static boolean ParseStrToBool(String s)
    {
        if (s.equals("1"))
            return true;
        return false;
    }

    private static int ParseStrToInt(String s)
    {
        if ((s == null) || s.equals(""))
            return 0;
        return Integer.parseInt(s);
    }


    public static void ResRead(String resFile, ResTableInfo TableInfo) throws Exception 
    {
    	DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();   
        DocumentBuilder db = null;
        	
        try
        {
            db = dbf.newDocumentBuilder();  
        }   
        catch (ParserConfigurationException ex)   
        {   
        	throw new Exception(ex);
        }  
        
        Document doc = db.parse(resFile); 
        
        Element root = doc.getDocumentElement();   
        if (root == null)
        	return;
        
        NodeList nlTables = root.getElementsByTagName(RSTable);
        if (nlTables.getLength() == 0) 
        	return;
        Element xeTable = (Element)nlTables.item(0);

        if (xeTable == null)
        	return;        

        ResTableHeaderInfo HeaderInfo = TableInfo.HeaderInfo;

        //header info
        HeaderInfo.Name = xeTable.getAttribute(RSName);
        HeaderInfo.Valid = ParseStrToBool(xeTable.getAttribute(RSValid));
        HeaderInfo.ResIndex = ParseStrToInt(xeTable.getAttribute(RSResIndex));
        HeaderInfo.DisplayName = xeTable.getAttribute(RSDisplayName);
        HeaderInfo.HeaderSign = xeTable.getAttribute(RSHeaderSign);
        HeaderInfo.ItemCount = ParseStrToInt(xeTable.getAttribute(RSItemCount));
        HeaderInfo.IndexCount = ParseStrToInt(xeTable.getAttribute(RSIndexCount));
        HeaderInfo.ConstraintCount = ParseStrToInt(xeTable.getAttribute(RSConstraintCount));
        HeaderInfo.PKName = xeTable.getAttribute(RSPKName);
        HeaderInfo.PK = xeTable.getAttribute(RSPK);
        HeaderInfo.Version = xeTable.getAttribute(RSVersion);
        HeaderInfo.CreateSign = xeTable.getAttribute(RSCreateSign);
        HeaderInfo.CreateTime = xeTable.getAttribute(RSCreateTime);
        HeaderInfo.LastUpdateSign = xeTable.getAttribute(RSLastUpdateSign);
        HeaderInfo.LastUpdateTime = xeTable.getAttribute(RSLastUpdateTime);

        Element xe;
        //rows
        NodeList xeRows = xeTable.getElementsByTagName(RSRows);
        if ((xeRows != null) && (xeRows.getLength() > 0))
        {
        	xe = (Element)xeRows.item(0);
        	xeRows = xe.getElementsByTagName(RSRow);
            for (int i = 0; i < xeRows.getLength(); i++)
            {
                xe = (Element)xeRows.item(i);

                ResRowInfo rowInfo = new ResRowInfo();

                rowInfo.Name = xe.getAttribute(RSName);
                rowInfo.Valid = ParseStrToBool(xe.getAttribute(RSValid));
                rowInfo.Visible = ParseStrToBool(xe.getAttribute(RSVisible));
                rowInfo.Remark = xe.getAttribute(RSRemark);
                rowInfo.IsPK = ParseStrToBool(xe.getAttribute(RSIsPK));
                rowInfo.Index = ParseStrToInt(xe.getAttribute(RSIndex));
                rowInfo.TypeName = xe.getAttribute(RSTypeName);
                rowInfo.Precision = ParseStrToInt(xe.getAttribute(RSPrecision));
                rowInfo.Length = ParseStrToInt(xe.getAttribute(RSLength));
                rowInfo.AllowNull = ParseStrToBool(xe.getAttribute(RSAllowNull));
                rowInfo.Identity = ParseStrToBool(xe.getAttribute(RSIdentity));
                rowInfo.Default = xe.getAttribute(RSDefault);
                rowInfo.OldColumnName = xe.getAttribute(RSOldColumnName);
                rowInfo.DisplayWidth = ParseStrToInt(xe.getAttribute(RSDisplayWidth));
                rowInfo.PickList = xe.getAttribute(RSPickList);
                rowInfo.Source = xe.getAttribute(RSSource);
                rowInfo.SourceItems = xe.getAttribute(RSSourceItems);
                rowInfo.DestItems = xe.getAttribute(RSDestItems);
                rowInfo.Reserved1 = xe.getAttribute(RSReserved1);
                rowInfo.Reserved2 = xe.getAttribute(RSReserved2);
                rowInfo.Reserved3 = xe.getAttribute(RSReserved3);
                rowInfo.Reserved4 = xe.getAttribute(RSReserved4);
                rowInfo.Reserved5 = xe.getAttribute(RSReserved5);
                rowInfo.Reserved6 = xe.getAttribute(RSReserved6);
                rowInfo.Reserved7 = xe.getAttribute(RSReserved7);

                TableInfo.RowList.add(rowInfo);
            }
        }

        //indexs
        NodeList xeIndexs = xeTable.getElementsByTagName(RSIndexs);
        if ((xeIndexs != null) && (xeIndexs.getLength() > 0))
        {
        	xe = (Element)xeIndexs.item(0);
        	xeIndexs = xe.getElementsByTagName(RSIndex);
        	for (int i = 0; i < xeIndexs.getLength(); i++)
            {
        		xe = (Element)xeIndexs.item(i);

                ResIndexInfo indexInfo = new ResIndexInfo();

                indexInfo.Name = xe.getAttribute(RSIndexName);
                indexInfo.Valid = ParseStrToBool(xe.getAttribute(RSValid));
                indexInfo.Remark = xe.getAttribute(RSRemark);
                indexInfo.TableName = xe.getAttribute(RSTableName);
                indexInfo.PrimaryKey = ParseStrToBool(xe.getAttribute(RSPrimaryKey));
                indexInfo.Constraint = ParseStrToBool(xe.getAttribute(RSConstraint));
                indexInfo.Unique = ParseStrToBool(xe.getAttribute(RSUnique));
                indexInfo.Clustered = ParseStrToBool(xe.getAttribute(RSClustered));
                indexInfo.IndexType = ParseStrToInt(xe.getAttribute(RSIndexType));
                indexInfo.AutoUpdate = ParseStrToBool(xe.getAttribute(RSAutoUpdate));
                indexInfo.NullCollation = ParseStrToInt(xe.getAttribute(RSNullCollation));
                indexInfo.OrdinalPosition = ParseStrToInt(xe.getAttribute(RSOrdinalPosition));
                indexInfo.ColumnName = xe.getAttribute(RSColumnName);
                indexInfo.Collation = ParseStrToInt(xe.getAttribute(RSCollation));
                indexInfo.Cardinality = ParseStrToInt(xe.getAttribute(RSCardinality));
                indexInfo.Integrated = ParseStrToBool(xe.getAttribute(RSIntegrated));

                TableInfo.IndexList.add(indexInfo);
            }
        }

        //relations
        NodeList xeRelations = xeTable.getElementsByTagName(RSConstraints);
        if ((xeRelations != null) && (xeRelations.getLength() > 0))
        {
        	xe = (Element)xeRelations.item(0);
        	xeRelations = xe.getElementsByTagName(RSConstraint);
            for (int i = 0; i < xeRelations.getLength(); i++)
            {
            	xe = (Element)xeIndexs.item(i);

                ResRelationInfo relationInfo = new ResRelationInfo();

                relationInfo.Name = xe.getAttribute(RSFKName);
                relationInfo.Valid = ParseStrToBool(xe.getAttribute(RSValid));
                relationInfo.Remark = xe.getAttribute(RSRemark);
                relationInfo.TableName = xe.getAttribute(RSTableName);
                relationInfo.PKTableName = xe.getAttribute(RSFKTableName);
                relationInfo.PKColumnName = xe.getAttribute(RSPKColumnName);
                relationInfo.FKTableName = xe.getAttribute(RSFKTableName);
                relationInfo.FKColumnName = xe.getAttribute(RSFKColumnName);
                relationInfo.Ordinal = ParseStrToInt(xe.getAttribute(RSOrdinal));
                relationInfo.UpdateRule = xe.getAttribute(RSUpdateRule);
                relationInfo.DeleteRule = xe.getAttribute(RSDeleteRule);
                relationInfo.PKName = xe.getAttribute(RSPKName);
                relationInfo.Deferrability = ParseStrToInt(xe.getAttribute(RSDeferrability));

                TableInfo.RelationList.add(relationInfo);
            }
        }
    }
}
